<?php

namespace App\Modules\Utilitarios\Controllers;
use App\Http\Controllers\Controller;
use App\Modules\Utilitarios\Models\Tag_art;
use Illuminate\Http\Request;
use Yajra\Datatables\Datatables;
use Illuminate\Support\Facades\Validator;
use DB;
class Tag_artController extends Controller
{
    protected $table;
    protected $table_pivot ='tag_relation';
    function __construct(){
        $this->middleware('auth');
        $this->table = new Tag_art();

    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {   
        return view('Utilitarios.views.tag_art');
    }
     /**
     * Display a listing of the datatables list.
     *
     */
    public function getTable()
    {   
        $table = Datatables::of($this->table::all());
        $table->addColumn('action', function($row){
            $url = url()->current().'/'.$row['id'];
            return view('layouts.buttons.buttons-dinamyc',['buttons'=> array(
                array('tipe'=>'edit',
                      'id_row'=>$row['id'],
                      'modal'=>'si',
                      'url'=>$url,
                      'class'=>" btn btn-sm  fn_edit btn-primary",
                      'icon'=>"icon-compose"
                ),
                array('tipe'=>'delete',
                      'id_row'=>$row['id'],
                      'modal'=>'no',
                      'url'=>$url,
                      'class'=>"btn btn-sm btn-danger fn_delete",
                      'icon'=>"icon-trash"
                )
            )]); 
        })->rawColumns(['action']);
        return $table->make(true);
    }
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
       if ($request->has('action')) {
            switch ($request->input("action")) {
                case 'showtable':
                    return $this->getTable();
                break;
                case 'add':
                    $validator = Validator::make($request->all(),[
                        'nombre' => 'required',
                        'slug' => 'required',
                    ]);
                    if ($validator->fails()) {
                       return response()->json(['error'=>$validator->errors()->all()]);
                    }else{
                        $this->table->fill($request->except(['action']))->save();
                        return response()->json(['success'=>'Registro agregado con exito','tablereload'=>'reload']);
                    }
                break;
            }
        }else{
             return response()->json(['error'=>'No existe ningun token por favor no borre nuesto codigo html']);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $data = $this->table::find($id);
        return view('Utilitarios.views.edit.tag_art')->with('data',$data);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
       
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $data = $this->table::find($id);
        if (!empty($data)) {
            $datos = $request->all();
            $data->nombre = $datos['nombre'];
            $data->slug = $datos['slug'];
            $data->descripcion = $datos['descripcion'];
            $data->save();
            return response()->json(['success'=>'Registro actualizado con exito','tablereload'=>'1']);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $short = substr($id, 0,3);
        if ($short == 'rel') {
            $id_pivot = explode('rel', $id);
            DB::table($this->table_pivot)->where('id', '=', $id_pivot[1])->delete();
            return response()->json(['success'=>'Registro eliminado con exito']);
        }else{
            $data  = $this->table::find($id);
            if (!empty($data)) {
                $data->delete();
                return response()->json(['success'=>'Registro eliminado con exito']);
            }
        }
    }
}
